os: Visual Studio 2015

environment:
  matrix:
    #- platform: x64
    #  target: x86_64-pc-windows-msvc
    #  qtdir: C:\Qt\5.10.1\msvc2015_64
    #  sysdirname: SysWOW64

    - platform: x86
      target: i686-pc-windows-msvc
      qtdir: C:\Qt\5.10.1\msvc2015
      sysdirname: system32

cache:
  CGAL-4.11.1-Setup.exe -> appveyor.yml

install:
  - if "%PLATFORM%" == "x86"
    call "C:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" x86
  - if "%PLATFORM%" == "x64"
    call "C:\Program Files\Microsoft SDKs\Windows\v7.1\Bin\SetEnv.cmd" /x64
  - if "%PLATFORM%" == "x64"
    call "C:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" x86_amd64
  - if not exist CGAL-4.11.1-Setup.exe
      appveyor DownloadFile https://github.com/CGAL/cgal/releases/download/releases/CGAL-4.11.1/CGAL-4.11.1-Setup.exe -FileName CGAL-4.11.1-Setup.exe
  - CGAL-4.11.1-Setup.exe /S /D=%APPVEYOR_BUILD_FOLDER%\CGAL-4.11.1
  - cd CGAL-4.11.1
  - mkdir build
  - cd build
  - if "%PLATFORM%" == "x86"
    cmake -G "Visual Studio 14 2015" ../ -DBOOST_INCLUDEDIR=C:\Libraries\boost_1_66_0
  - if "%PLATFORM%" == "x64"
    cmake -G "Visual Studio 14 2015 Win64" ../ -DBOOST_INCLUDEDIR=C:\Libraries\boost_1_66_0
  - msbuild /p:Configuration=Release ALL_BUILD.vcxproj
  - cd %APPVEYOR_BUILD_FOLDER%

build: false

test_script:
  - set PATH=%PATH%;%QTDIR%\bin
  - qmake "BOOST_INCLUDEDIR=C:\Libraries\boost_1_66_0" "CGAL_DIR=%APPVEYOR_BUILD_FOLDER%\CGAL-4.11.1"
  - nmake -f Makefile.Release

after_test:
  # Check deps by Dependency Walker
  # Check Qt plugins by following https://wiki.qt.io/Deploy_an_Application_on_Windows
  - set TAG=%APPVEYOR_REPO_TAG_NAME%
  - if "%TAG%" == ""
    set TAG=unstable
  - 7z a dust3d-%TAG%-%PLATFORM%.zip %APPVEYOR_BUILD_FOLDER%\release\dust3d.exe
  - 7z a dust3d-%TAG%-%PLATFORM%.zip %APPVEYOR_BUILD_FOLDER%\thirdparty\meshlite\meshlite_unstable_vc14_%PLATFORM%\meshlite_ffi.dll
  - 7z a dust3d-%TAG%-%PLATFORM%.zip %APPVEYOR_BUILD_FOLDER%\CGAL-4.11.1\build\bin\Release\CGAL-vc140-mt-4.11.1.dll
  - 7z a dust3d-%TAG%-%PLATFORM%.zip %APPVEYOR_BUILD_FOLDER%\CGAL-4.11.1\auxiliary\gmp\lib\libgmp-10.dll
  - 7z a dust3d-%TAG%-%PLATFORM%.zip %APPVEYOR_BUILD_FOLDER%\CGAL-4.11.1\auxiliary\gmp\lib\libmpfr-4.dll
  - 7z a dust3d-%TAG%-%PLATFORM%.zip %APPVEYOR_BUILD_FOLDER%\ci\opengl32sw.dll
  - 7z a dust3d-%TAG%-%PLATFORM%.zip %QTDIR%\bin\Qt5Widgets.dll
  - 7z a dust3d-%TAG%-%PLATFORM%.zip %QTDIR%\bin\Qt5Gui.dll
  - 7z a dust3d-%TAG%-%PLATFORM%.zip %QTDIR%\bin\Qt5Core.dll
  - 7z a dust3d-%TAG%-%PLATFORM%.zip "C:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\redist\%PLATFORM%\Microsoft.VC140.CRT\msvcp140.dll"
  - 7z a dust3d-%TAG%-%PLATFORM%.zip "C:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\redist\%PLATFORM%\Microsoft.VC140.CRT\vcruntime140.dll"
  - mkdir platforms
  - copy %QTDIR%\plugins\platforms\qwindows.dll %APPVEYOR_BUILD_FOLDER%\platforms\qwindows.dll
  - 7z a dust3d-%TAG%-%PLATFORM%.zip -r %APPVEYOR_BUILD_FOLDER%\platforms\
  - mkdir imageformats
  - copy %QTDIR%\plugins\imageformats\qjpeg.dll %APPVEYOR_BUILD_FOLDER%\imageformats\qjpeg.dll
  - 7z a dust3d-%TAG%-%PLATFORM%.zip -r %APPVEYOR_BUILD_FOLDER%\imageformats\

artifacts:
  - path: '*.zip'
    name: platform_zips

deploy:
  - provider: GitHub
    release: $(TAG)
    force_update: true
    auth_token:
      secure: Rhzhefjk89WN2tDht8vVKYAojGfR23LhDPKPxhQwbT7k3qswSWjmoFoDTpIHNfc0
    artifact: platform_zips
    draft: false
    prerelease: false
    on:
      branch: master

  - provider: GitHub
    release: $(TAG)
    force_update: true
    auth_token:
      secure: Rhzhefjk89WN2tDht8vVKYAojGfR23LhDPKPxhQwbT7k3qswSWjmoFoDTpIHNfc0
    artifact: platform_zips
    draft: false
    prerelease: false
    on:
      APPVEYOR_REPO_TAG: true
